#!/usr/bin/perl
#################################################################################
#										#
# circle x-calc table generator for libmio					#
# copyright (c) 2006-2008 Joerg Wolfram (joerg@jcwolfram.de)			#
#										#
#										#
# This program is free software; you can redistribute it and/or			#
# modify it under the terms of the GNU General Public License			#
# as published by the Free Software Foundation; either version 2		#
# of the License, or (at your option) any later version.			#
#										#
# This program is distributed in the hope that it will be useful,		#
# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
# General Public License for more details.					#
#										#
# You should have received a copy of the GNU General Public			#
# License along with this library; if not, write to the				#
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
# Boston, MA 02111-1307, USA.							#
#										#
#################################################################################
for($y=0;$y<2;$y++)
{
    for($x=0;$x<2;$x++)
    {
	for($dy=0;$dy<8;$dy++)
	{
	    for($dx=0;$dx<8;$dx++)
	    {
		$cno=128*$y+16*$dy+8*$x+$dx;
		$angle=atan2(($dx+0.1),($dy+0.1))*18/3.14152+0.45;
#		print	$y."-".$x."-".$dy."-".$dx."=".$angle."\n";
		if (($y==0)&&($x==0))
		{
		    $value=$angle;
		}
		if (($y==0)&&($x==1))
		{
		    $value=36-$angle;
		}
		if (($y==1)&&($x==0))
		{
		    $value=18-$angle;
		}
		if (($y==1)&&($x==1))
		{
		    $value=18+$angle;
		}
		if ($value>36)
		{
		    $value-=36;
		}

		$scell[$cno]=$value;
	    }
	}
    }	    	
}



###############################################################################
# write table
###############################################################################
open (WTAB, ">../gps_rtab.inc");
    for($i=0;$i<16;$i++)
    {
        print WTAB "        .db "; 
        for($j=0;$j<16;$j++)
        {
	    $cellpos=$i*16+$j;
	    $y=$scell[$cellpos];
	    if ($y<1) {printf WTAB "0x00"} 
	    else {printf WTAB "%#2.2x",$y};
	    if ($j<15) {print WTAB ","}
	    else {print WTAB "\n"};
	}
    }
close(WTAB);

