;################################################################################
;#										#
;# avr-chipbasic2M - mobile single chip basic computer with ATmega644		#
;# timer menu									#
;# copyright (c) 2008 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;#										#
;# This program is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU General Public License			#
;# as published by the Free Software Foundation; either version 2		#
;# of the License, or (at your option) any later version.			#
;#										#
;# This program is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the GNU		#
;# General Public License for more details.					#
;#										#
;# You should have received a copy of the GNU General Public			#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

timer_menu:	lds	tempreg2,libmio_rtc
		sbrc	tempreg2,0
		rjmp	timer_menu_0
		rcall	timer_stwa
		ldi	tempreg2,1
		jmp	menu_main_re
		
timer_menu_0:  	clr	tempreg2
timer_menu_re:	sts	libmio_font,const_0
		ldi	ZL,LOW(menudata_timer*2)
		ldi	ZH,HIGH(menudata_timer*2)
		lds	XL,libmio_rtc
		ori	XL,2
		sts	libmio_rtc,XL
		libmio_copymenu
timer_menu_1:	set
		ldi	r19,3			;3 entries
		libmio_menu5
		cpi	tempreg1,0xed		;ESC
		brne	timer_menu_9
		lds	XL,libmio_rtc
		andi	XL,0xfd
		sts	libmio_rtc,XL
		ret
		
timer_menu_9:	cpi	tempreg1,0xea
		brne	timer_menu_1				

timer_menu_2:	cpi	tempreg2,0		;stopp-watch
		brne	timer_menu_3
		rcall	timer_stwa
		clr	tempreg2
		rjmp	timer_menu_re

timer_menu_3:	cpi	tempreg2,1		;alarm
		brne	timer_menu_4
		rjmp	timer_mal

timer_menu_4: 	rjmp	timer_menus		;set clock

